# sc::FinDispMolecularHessian Class Reference

Computes the molecular hessian by finite displacements of gradients. More...

`#include <fdhess.h>`

Inheritance diagram for sc::FinDispMolecularHessian:

List of all members.

## Public Member Functions
| FinDispMolecularHessian (const Ref< MolecularEnergy > &)
| FinDispMolecularHessian (const Ref< KeyVal > &)
| The FinDispMolecularHessian KeyVal constructor is used to generate a FinDispMolecularHessian object from the input.
| FinDispMolecularHessian (StateIn &)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.
RefSymmSCMatrix | compute_hessian_from_gradients ()
| These members are used to compute a cartesian hessian from gradients at finite displacements.
int | ndisplace () const
int | ndisplacements_done () const
RefSCMatrix | displacements (int irrep) const
void | displace (int disp)
void | original_geometry ()
void | set_gradient (int disp, const RefSCVector &grad)
void | checkpoint_displacements (StateOut &)
void | restore_displacements (StateIn &)
RefSymmSCMatrix | cartesian_hessian ()
| This returns the cartesian hessian.
void | set_checkpoint (int c)
| Set checkpoint option.
int | checkpoint () const
| Return the current value of the checkpoint option.
void | set_energy (const Ref< MolecularEnergy > &energy)
| Some MolecularHessian specializations require a molecular energy object.
MolecularEnergy * | energy () const
| This returns a MolecularEnergy object, if used by this specialization.
Ref< SCMatrixKit > | matrixkit () const
RefSCDimension | d3natom () const
## Protected Member Functions
void | get_disp (int disp, int &irrep, int &index, double &coef)
void | do_hess_for_irrep (int irrep, const RefSymmSCMatrix &dhessian, const RefSymmSCMatrix &xhessian)
void | init ()
void | restart ()
## Protected Attributes
Ref< MolecularEnergy > | mole_
Ref< PointGroup > | displacement_point_group_
Ref< PointGroup > | original_point_group_
RefSCVector | original_geometry_
double | disp_
double | accuracy_
int | ndisp_
int | nirrep_
int | restart_
char * | restart_file_
int | checkpoint_
char * | checkpoint_file_
int | only_totally_symmetric_
int | eliminate_cubic_terms_
int | do_null_displacement_
int | debug_
RefSCMatrix | symbasis_
RefSCVector * | gradients_

## Detailed Description

Computes the molecular hessian by finite displacements of gradients.

This will use the minimum number of displacements, each in the highest possible point group.

## Constructor & Destructor Documentation

sc::FinDispMolecularHessian::FinDispMolecularHessian | ( | const Ref< KeyVal > & |  | ) |

The FinDispMolecularHessian KeyVal constructor is used to generate a FinDispMolecularHessian object from the input.

It reads the keywords below.

Keyword | Type | Default | Description
`energy` | MolecularEnergy | none | This gives an object which will be used to compute the gradients needed to form the hessian. If this is not specified, the object using FinDispMolecularHessian will, in some cases, fill it in appropriately. However, even in these cases, it may be desirable to specify this keyword. For example, this could be used in an optimization to compute frequencies using a lower level of theory.
`debug` | boolean | false | If true, print out debugging information.
`point_group` | PointGroup | none | The point group to use for generating the displacements.
`restart` | boolean | true | If true, and a checkpoint file exists, restart from that file.
`restart_file` | string | basename`.ckpt.hess` | The name of the file where checkpoint information is written to or read from.
`checkpoint` | boolean | true | If true, checkpoint intermediate data.
`only_totally_symmetric` | boolean | false | If true, only follow totally symmetric displacments. The hessian will not be complete, but it has enough information to use it in a geometry optimization.
`eliminate_cubic_terms` | boolean | true | If true, then cubic terms will be eliminated. This requires that two displacements are done for each totally symmetric coordinate, rather than one. Setting this to false will reduce the accuracy, but the results will still probably be accurate enough for a geometry optimization.
`do_null_displacement` | boolean | true | Run the calculation at the given geometry as well.
`displacement` | double | 1.0e-2 | The size of the displacement in Bohr.
`gradient_accuracy` | double | `displacement` / 1000 | The accuracy to which the gradients will be computed.

## Member Function Documentation

RefSymmSCMatrix sc::FinDispMolecularHessian::cartesian_hessian | ( |  | ) | `[virtual]`

This returns the cartesian hessian.

If it has not yet been computed, it will be computed by finite displacements.

Implements sc::MolecularHessian.

RefSymmSCMatrix sc::FinDispMolecularHessian::compute_hessian_from_gradients | ( |  | ) |

These members are used to compute a cartesian hessian from gradients at finite displacements.

MolecularEnergy* sc::FinDispMolecularHessian::energy | ( |  | ) | const`[virtual]`

This returns a MolecularEnergy object, if used by this specialization.

Otherwise null is returned.

Reimplemented from sc::MolecularHessian.

void sc::FinDispMolecularHessian::save_data_state | ( | StateOut & |  | ) | `[virtual]`

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::MolecularHessian.

void sc::FinDispMolecularHessian::set_energy | ( | const Ref< MolecularEnergy > & | energy | ) | `[virtual]`

Some MolecularHessian specializations require a molecular energy object.

The default implementations of this ignores the argument.

Reimplemented from sc::MolecularHessian.

The documentation for this class was generated from the following file:

- fdhess.h